(* (<||>) : (bool * bool) -> (bool * bool) -> (bool * bool) *)
let (<||>) (b1,w1) (b2,w2) = (b1 || b2,w1 || w2)

(* beans : int -> int -> (bool * bool) *)
let rec beans b w =
 if b = 1 && w = 0 then (true,false)
 else if b = 0 && w = 1 then (false,true)
 else if b < 0 || w < 0 then (false, false)
 else 
  (beans (b-2) (w+1)) <||>
  (beans (b+1) (w-2)) <||>
  (beans (b-1) w)

(* module : L *)
module L = Lookup

(* beans_dp : int -> int -> (bool * bool) *)
let beans_dp b w = 
 let rec beans t b w =
  if L.mem t (b,w) then t else
  if b = 1 && w = 0 then L.add t (b,w) (true,false)
  else if b = 0 && w = 1 then L.add t (b,w) (false,true)
  else if b < 0 || w < 0 then L.add t (b,w) (false, false)
  else 
   let t = beans t (b-2) (w+1) in
   let t = beans t (b+1) (w-2) in
   let t = beans t (b-1) w in
   let r = L.find t (b-2,w+1) <||> L.find t (b+1,w-2) <||> L.find t (b-1,w) in
   L.add t (b,w) r
 in L.find (beans L.empty b w) (b,w)
