(*
lookup module on binary trees;
trees may not be balanced 
*)
module Bt = BinTree

type ('a,'b) t = ('a*'b) Bt.t 
(* empty: ('a,'b) t *)
let empty = Bt.Empty;;
(* mem: ('a,'b) t -> 'a -> bool *)
let rec mem t k = match t with
 | Bt.Empty -> false
 | Bt.Node(l,(n,v),r) -> match compare k n with
  | -1 -> mem l k
  | 0 -> true
  | 1 -> mem r k
(* find : ('a,'b) t -> 'a -> 'b *)
let rec find t k = match t with
 | Bt.Empty -> raise Not_found
 | Bt.Node(l,(n,v),r) -> match compare k n with
  | -1 -> find l k
  | 0 -> v
  | 1 -> find r k
(* insert : ('a,'b) t -> 'a -> 'b -> ('a,'b t) *)
let rec insert t k v = match t with
 | Bt.Empty -> Bt.Node(Bt.Empty,(k,v), Bt.Empty)
 | Bt.Node(l,node,r) -> match compare k (fst node) with
  | -1 -> Bt.Node(insert l k v,node,r)
  | 0 -> failwith "Lookup.insert: key already present"
  | 1 -> Bt.Node(l,node,insert r k v)
(* add : ('a,'b) t -> 'a -> 'b -> ('a,'b) t *)
let add t k v = if mem t k then t else insert t k v
(* size : ('a,'b) t -> int *)
let size = Bt.size
