(** Lookup Tables *)
type ('a,'b) t
(** the type of a lookup table *)
val empty: ('a,'b) t
(** [empty] constructs empty [t] *)
val mem: ('a,'b) t -> 'a -> bool 
(** [mem t k] tests if there is a value associated with key [k] in [t] *)
val find : ('a,'b) t -> 'a -> 'b
(** [find t k] returns value [v] associated with key [k] in [t] 
 @raise Not_Found if [t] has no binding for [k] *)
val add : ('a,'b) t -> 'a -> 'b -> ('a,'b) t
(** [add t k v] adds key-value pair [(k,v)] to [t] if [k] is not in [t] *)
val size : ('a,'b) t -> int
(** [size t] returns the size, i.e., number of bindings in [t] *)
